
;;----------------------- bfi.asm -------------------------;;
;;                                                         ;;
;;                 Developed by Solidus117                 ;;
;;                      Version 1.0                        ;;
;;                                                         ;;
;; Please see the accompanying documentation for source    ;;
;; tree and OS/API-specific functions. Assemble with FASM  ;;
;;                                                         ;;
;;                http://flatassembler.net                 ;;
;;                                                         ;;
;; This software carries NO warranty and the author        ;;
;; releases this source into the PUBLIC DOMAIN, implying   ;;
;; that under no circumstance shall the author be          ;;
;; accountable for any resultant damage caused by the      ;;
;; assembled source code.                                  ;;
;;                                                         ;;
;;---------------------------------------------------------;;

	include "lib/StandardIO.ah"
	include "lib/StandardLIB.ah"
	include "lib/Definitions.ah"

	define  BUFR_SZ 32768			;; 32k File Buffer Size
	define  MEM_SZ  16384			;; 32k Virtual Memory Size

	
;;  CLI Header:  ------------------------------------------;;
	
	use32
	org   400000h
	jmp   entry_point
	db    'DEX1'

	
;;  Shared Code Objects:  ---------------------------------;;
	
	IO	StandardIO
	LIB	StandardLIB
	
	
;;  Data:  ------------------------------------------------;;

	newline	db	CR, CR, NUL
	lbreak	db	CR, CR, CR, CR, NUL
	
	errmsg	db	'File I/O Error. Exiting ...',CR,NUL

	CLIparams:	times 128 db 0
	paramptr	dd	0
	

;;  Main Execution Entry:  --------------------------------;;

	entry_point:
		libentry							;; Setup Calltable

		getparams CLIparams					;; Get CLI Parameters
		call CLIparameter_parse				;; Get the Filename from Parameters

		mov   eax,[paramptr]				;; Load the file to position
		fread loadpoint,eax,FDD,NUL

		call   Interpret					;; Enter Interpreter

	exit_point:
		prints newline						;; Clean Up and Exit
		libexit


;; Subroutines  -------------------------------------------;;

	include "subroutines.asm"


;; Extra Inclusions  --------------------------------------;;
	
	include "lib/Dex.inc"

	memory:		times MEM_SZ  db 0
	loadpoint:	times BUFR_SZ rb 0

