
;;-------------------- subroutines.asm --------------------;;
;;                                                         ;;
;;---------------------------------------------------------;;

include "lib/Definitions.ah"

macro case op1,op2
	{
	cmp  byte [edx],op1
	je   op2
	}

;;---------------------------------------------------------;;
;; CLIparameter_parse:                                     ;;
;;    Proceed through parameter string until a space is    ;;
;;    found, then set the filename pointer to that memory  ;;
;;    location. A NULL automatically follows.              ;;
;;---------------------------------------------------------;;

	CLIparameter_parse:
		mov  ebx,CLIparams
	@@:	cmp  byte [ebx],' '
      	je   @f
		inc  ebx
		jmp  @b
	@@: inc  ebx
		mov  [paramptr],ebx
	ret	

;;---------------------------------------------------------;;
;; Interpret                                               ;;
;;   Interpret the Brainfuck source, acting upon the VMM   ;;
;;---------------------------------------------------------;;
	Interpret:
		mov  edx,loadpoint-1
		mov  ebx,memory

	lp:	inc  edx
		case '+',incval
		case '-',decval
		case '>',incptr
		case '<',decptr
		case '.',putval
		case ',',getval
		case '[',tstjmp
		case ']',uncjmp
		case 00h,@f
		jmp  lp
	@@:	ret

	incval:
		inc byte [ebx]
		jmp lp
		
	decval:
		dec byte [ebx]
		jmp lp

	incptr:
		inc ebx
		jmp lp
		
	decptr:
		dec ebx
		jmp lp
	
	getval:
		call [WaitForKeyPress]
		mov  byte [ebx],al
		jmp  lp

	putval:
		mov  al,byte [ebx]
		call [PrintCharCursor]
		jmp  lp

	tstjmp:
		cmp  byte [ebx],NUL
		je   tstjmp2
		jmp  lp
	tstjmp2:
		mov  ecx,edx			;; Transfer IP Pointer to C
	@@:	inc  edx
		cmp  byte [edx],']'
		je   tstjmp3
		cmp  byte [edx],NUL
		je   restore_IP
		jmp  @b
	tstjmp3:
		jmp  lp

	restore_IP:
		mov  edx,ecx
		dec  edx
		jmp  lp

	uncjmp:
		dec  edx
		cmp  byte [edx],'['
		je   uncjmp2
		jmp  uncjmp

	uncjmp2:
		dec  edx
		jmp  lp

;;---------------------------------------------------------;;
